/* abstractlist.c generated by valac 0.46.6, the Vala compiler
 * generated from abstractlist.vala, do not modify */

/* abstractlist.vala
 *
 * Copyright (C) 2007  Jürg Billeter
 * Copyright (C) 2009  Didier Villevalois
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Didier 'Ptitjes' Villevalois <ptitjes@free.fr>
 */

#include <glib-object.h>
#include <glib.h>

#define GEE_TYPE_TRAVERSABLE (gee_traversable_get_type ())
#define GEE_TRAVERSABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_TRAVERSABLE, GeeTraversable))
#define GEE_IS_TRAVERSABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_TRAVERSABLE))
#define GEE_TRAVERSABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_TRAVERSABLE, GeeTraversableIface))

typedef struct _GeeTraversable GeeTraversable;
typedef struct _GeeTraversableIface GeeTraversableIface;
typedef gboolean (*GeeForallFunc) (gpointer g, gpointer user_data);
typedef enum  {
	GEE_TRAVERSABLE_STREAM_YIELD,
	GEE_TRAVERSABLE_STREAM_CONTINUE,
	GEE_TRAVERSABLE_STREAM_END,
	GEE_TRAVERSABLE_STREAM_WAIT
} GeeTraversableStream;

#define GEE_TRAVERSABLE_TYPE_STREAM (gee_traversable_stream_get_type ())

#define GEE_TYPE_LAZY (gee_lazy_get_type ())
#define GEE_LAZY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_LAZY, GeeLazy))
#define GEE_LAZY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_LAZY, GeeLazyClass))
#define GEE_IS_LAZY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_LAZY))
#define GEE_IS_LAZY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_LAZY))
#define GEE_LAZY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_LAZY, GeeLazyClass))

typedef struct _GeeLazy GeeLazy;
typedef struct _GeeLazyClass GeeLazyClass;
typedef GeeTraversableStream (*GeeStreamFunc) (GeeTraversableStream state, GeeLazy* g, GeeLazy* * lazy, gpointer user_data);

#define GEE_TYPE_ITERATOR (gee_iterator_get_type ())
#define GEE_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ITERATOR, GeeIterator))
#define GEE_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ITERATOR))
#define GEE_ITERATOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_ITERATOR, GeeIteratorIface))

typedef struct _GeeIterator GeeIterator;
typedef struct _GeeIteratorIface GeeIteratorIface;
typedef gpointer (*GeeFoldFunc) (gpointer g, gpointer a, gpointer user_data);
typedef gpointer (*GeeMapFunc) (gpointer g, gpointer user_data);
typedef gboolean (*GeePredicate) (gconstpointer g, gpointer user_data);
typedef GeeIterator* (*GeeFlatMapFunc) (gpointer g, gpointer user_data);

#define GEE_TYPE_ITERABLE (gee_iterable_get_type ())
#define GEE_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ITERABLE, GeeIterable))
#define GEE_IS_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ITERABLE))
#define GEE_ITERABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_ITERABLE, GeeIterableIface))

typedef struct _GeeIterable GeeIterable;
typedef struct _GeeIterableIface GeeIterableIface;

#define GEE_TYPE_COLLECTION (gee_collection_get_type ())
#define GEE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_COLLECTION, GeeCollection))
#define GEE_IS_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_COLLECTION))
#define GEE_COLLECTION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_COLLECTION, GeeCollectionIface))

typedef struct _GeeCollection GeeCollection;
typedef struct _GeeCollectionIface GeeCollectionIface;

#define GEE_TYPE_ABSTRACT_COLLECTION (gee_abstract_collection_get_type ())
#define GEE_ABSTRACT_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection))
#define GEE_ABSTRACT_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollectionClass))
#define GEE_IS_ABSTRACT_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ABSTRACT_COLLECTION))
#define GEE_IS_ABSTRACT_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_ABSTRACT_COLLECTION))
#define GEE_ABSTRACT_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollectionClass))

typedef struct _GeeAbstractCollection GeeAbstractCollection;
typedef struct _GeeAbstractCollectionClass GeeAbstractCollectionClass;
typedef struct _GeeAbstractCollectionPrivate GeeAbstractCollectionPrivate;

#define GEE_TYPE_LIST (gee_list_get_type ())
#define GEE_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_LIST, GeeList))
#define GEE_IS_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_LIST))
#define GEE_LIST_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_LIST, GeeListIface))

typedef struct _GeeList GeeList;
typedef struct _GeeListIface GeeListIface;

#define GEE_TYPE_LIST_ITERATOR (gee_list_iterator_get_type ())
#define GEE_LIST_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_LIST_ITERATOR, GeeListIterator))
#define GEE_IS_LIST_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_LIST_ITERATOR))
#define GEE_LIST_ITERATOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_LIST_ITERATOR, GeeListIteratorIface))

typedef struct _GeeListIterator GeeListIterator;
typedef struct _GeeListIteratorIface GeeListIteratorIface;

#define GEE_TYPE_ABSTRACT_LIST (gee_abstract_list_get_type ())
#define GEE_ABSTRACT_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ABSTRACT_LIST, GeeAbstractList))
#define GEE_ABSTRACT_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_ABSTRACT_LIST, GeeAbstractListClass))
#define GEE_IS_ABSTRACT_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ABSTRACT_LIST))
#define GEE_IS_ABSTRACT_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_ABSTRACT_LIST))
#define GEE_ABSTRACT_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_ABSTRACT_LIST, GeeAbstractListClass))

typedef struct _GeeAbstractList GeeAbstractList;
typedef struct _GeeAbstractListClass GeeAbstractListClass;
typedef struct _GeeAbstractListPrivate GeeAbstractListPrivate;
enum  {
	GEE_ABSTRACT_LIST_0_PROPERTY,
	GEE_ABSTRACT_LIST_G_TYPE,
	GEE_ABSTRACT_LIST_G_DUP_FUNC,
	GEE_ABSTRACT_LIST_G_DESTROY_FUNC,
	GEE_ABSTRACT_LIST_READ_ONLY_VIEW_PROPERTY,
	GEE_ABSTRACT_LIST_NUM_PROPERTIES
};
static GParamSpec* gee_abstract_list_properties[GEE_ABSTRACT_LIST_NUM_PROPERTIES];

#define GEE_TYPE_READ_ONLY_COLLECTION (gee_read_only_collection_get_type ())
#define GEE_READ_ONLY_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_READ_ONLY_COLLECTION, GeeReadOnlyCollection))
#define GEE_READ_ONLY_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_READ_ONLY_COLLECTION, GeeReadOnlyCollectionClass))
#define GEE_IS_READ_ONLY_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_READ_ONLY_COLLECTION))
#define GEE_IS_READ_ONLY_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_READ_ONLY_COLLECTION))
#define GEE_READ_ONLY_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_READ_ONLY_COLLECTION, GeeReadOnlyCollectionClass))

typedef struct _GeeReadOnlyCollection GeeReadOnlyCollection;
typedef struct _GeeReadOnlyCollectionClass GeeReadOnlyCollectionClass;

#define GEE_TYPE_READ_ONLY_LIST (gee_read_only_list_get_type ())
#define GEE_READ_ONLY_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_READ_ONLY_LIST, GeeReadOnlyList))
#define GEE_READ_ONLY_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_READ_ONLY_LIST, GeeReadOnlyListClass))
#define GEE_IS_READ_ONLY_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_READ_ONLY_LIST))
#define GEE_IS_READ_ONLY_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_READ_ONLY_LIST))
#define GEE_READ_ONLY_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_READ_ONLY_LIST, GeeReadOnlyListClass))

typedef struct _GeeReadOnlyList GeeReadOnlyList;
typedef struct _GeeReadOnlyListClass GeeReadOnlyListClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _GeeIteratorIface {
	GTypeInterface parent_iface;
	gboolean (*next) (GeeIterator* self);
	gboolean (*has_next) (GeeIterator* self);
	gpointer (*get) (GeeIterator* self);
	void (*remove) (GeeIterator* self);
	gboolean (*get_valid) (GeeIterator* self);
	gboolean (*get_read_only) (GeeIterator* self);
};

struct _GeeTraversableIface {
	GTypeInterface parent_iface;
	GType (*get_g_type) (GeeTraversable* self);
	GBoxedCopyFunc (*get_g_dup_func) (GeeTraversable* self);
	GDestroyNotify (*get_g_destroy_func) (GeeTraversable* self);
	gboolean (*foreach) (GeeTraversable* self, GeeForallFunc f, gpointer f_target);
	GeeIterator* (*stream) (GeeTraversable* self, GType a_type, GBoxedCopyFunc a_dup_func, GDestroyNotify a_destroy_func, GeeStreamFunc f, gpointer f_target, GDestroyNotify f_target_destroy_notify);
	gpointer (*fold) (GeeTraversable* self, GType a_type, GBoxedCopyFunc a_dup_func, GDestroyNotify a_destroy_func, GeeFoldFunc f, gpointer f_target, gpointer seed);
	GeeIterator* (*map) (GeeTraversable* self, GType a_type, GBoxedCopyFunc a_dup_func, GDestroyNotify a_destroy_func, GeeMapFunc f, gpointer f_target);
	GeeIterator* (*scan) (GeeTraversable* self, GType a_type, GBoxedCopyFunc a_dup_func, GDestroyNotify a_destroy_func, GeeFoldFunc f, gpointer f_target, gpointer seed);
	GeeIterator* (*filter) (GeeTraversable* self, GeePredicate pred, gpointer pred_target, GDestroyNotify pred_target_destroy_notify);
	GeeIterator* (*chop) (GeeTraversable* self, gint offset, gint length);
	GType (*get_element_type) (GeeTraversable* self);
	GeeIterator* (*flat_map) (GeeTraversable* self, GType a_type, GBoxedCopyFunc a_dup_func, GDestroyNotify a_destroy_func, GeeFlatMapFunc f, gpointer f_target, GDestroyNotify f_target_destroy_notify);
	GeeIterator** (*tee) (GeeTraversable* self, guint forks, gint* result_length1);
	gpointer (*first_match) (GeeTraversable* self, GeePredicate pred, gpointer pred_target, GDestroyNotify pred_target_destroy_notify);
	gboolean (*any_match) (GeeTraversable* self, GeePredicate pred, gpointer pred_target, GDestroyNotify pred_target_destroy_notify);
	gboolean (*all_match) (GeeTraversable* self, GeePredicate pred, gpointer pred_target, GDestroyNotify pred_target_destroy_notify);
	gpointer (*max) (GeeTraversable* self, GCompareDataFunc compare, gpointer compare_target, GDestroyNotify compare_target_destroy_notify);
	gpointer (*min) (GeeTraversable* self, GCompareDataFunc compare, gpointer compare_target, GDestroyNotify compare_target_destroy_notify);
	GeeIterator* (*order_by) (GeeTraversable* self, GCompareDataFunc compare, gpointer compare_target, GDestroyNotify compare_target_destroy_notify);
};

struct _GeeIterableIface {
	GTypeInterface parent_iface;
	GType (*get_g_type) (GeeIterable* self);
	GBoxedCopyFunc (*get_g_dup_func) (GeeIterable* self);
	GDestroyNotify (*get_g_destroy_func) (GeeIterable* self);
	GeeIterator* (*iterator) (GeeIterable* self);
};

struct _GeeCollectionIface {
	GTypeInterface parent_iface;
	GType (*get_g_type) (GeeCollection* self);
	GBoxedCopyFunc (*get_g_dup_func) (GeeCollection* self);
	GDestroyNotify (*get_g_destroy_func) (GeeCollection* self);
	gboolean (*contains) (GeeCollection* self, gconstpointer item);
	gboolean (*add) (GeeCollection* self, gconstpointer item);
	gboolean (*remove) (GeeCollection* self, gconstpointer item);
	void (*clear) (GeeCollection* self);
	gboolean (*add_all) (GeeCollection* self, GeeCollection* collection);
	gboolean (*contains_all) (GeeCollection* self, GeeCollection* collection);
	gboolean (*remove_all) (GeeCollection* self, GeeCollection* collection);
	gboolean (*retain_all) (GeeCollection* self, GeeCollection* collection);
	gpointer* (*to_array) (GeeCollection* self, gint* result_length1);
	gint (*get_size) (GeeCollection* self);
	gboolean (*get_is_empty) (GeeCollection* self);
	gboolean (*get_read_only) (GeeCollection* self);
	GeeCollection* (*get_read_only_view) (GeeCollection* self);
	gboolean (*add_all_array) (GeeCollection* self, gpointer* array, gint array_length1);
	gboolean (*contains_all_array) (GeeCollection* self, gpointer* array, gint array_length1);
	gboolean (*remove_all_array) (GeeCollection* self, gpointer* array, gint array_length1);
	gboolean (*add_all_iterator) (GeeCollection* self, GeeIterator* iter);
	gboolean (*contains_all_iterator) (GeeCollection* self, GeeIterator* iter);
	gboolean (*remove_all_iterator) (GeeCollection* self, GeeIterator* iter);
};

struct _GeeAbstractCollection {
	GObject parent_instance;
	GeeAbstractCollectionPrivate * priv;
};

struct _GeeAbstractCollectionClass {
	GObjectClass parent_class;
	gboolean (*contains) (GeeAbstractCollection* self, gconstpointer item);
	gboolean (*add) (GeeAbstractCollection* self, gconstpointer item);
	gboolean (*remove) (GeeAbstractCollection* self, gconstpointer item);
	void (*clear) (GeeAbstractCollection* self);
	GeeIterator* (*iterator) (GeeAbstractCollection* self);
	gboolean (*foreach) (GeeAbstractCollection* self, GeeForallFunc f, gpointer f_target);
	void (*reserved0) (GeeAbstractCollection* self);
	void (*reserved1) (GeeAbstractCollection* self);
	void (*reserved2) (GeeAbstractCollection* self);
	void (*reserved3) (GeeAbstractCollection* self);
	void (*reserved4) (GeeAbstractCollection* self);
	void (*reserved5) (GeeAbstractCollection* self);
	void (*reserved6) (GeeAbstractCollection* self);
	void (*reserved7) (GeeAbstractCollection* self);
	void (*reserved8) (GeeAbstractCollection* self);
	void (*reserved9) (GeeAbstractCollection* self);
	gint (*get_size) (GeeAbstractCollection* self);
	gboolean (*get_read_only) (GeeAbstractCollection* self);
	GeeCollection* (*get_read_only_view) (GeeAbstractCollection* self);
};

struct _GeeListIteratorIface {
	GTypeInterface parent_iface;
	void (*set) (GeeListIterator* self, gconstpointer item);
	void (*add) (GeeListIterator* self, gconstpointer item);
	gint (*index) (GeeListIterator* self);
};

struct _GeeListIface {
	GTypeInterface parent_iface;
	GType (*get_g_type) (GeeList* self);
	GBoxedCopyFunc (*get_g_dup_func) (GeeList* self);
	GDestroyNotify (*get_g_destroy_func) (GeeList* self);
	GeeListIterator* (*list_iterator) (GeeList* self);
	gpointer (*get) (GeeList* self, gint index);
	void (*set) (GeeList* self, gint index, gconstpointer item);
	gint (*index_of) (GeeList* self, gconstpointer item);
	void (*insert) (GeeList* self, gint index, gconstpointer item);
	gpointer (*remove_at) (GeeList* self, gint index);
	GeeList* (*slice) (GeeList* self, gint start, gint stop);
	gpointer (*first) (GeeList* self);
	gpointer (*last) (GeeList* self);
	void (*insert_all) (GeeList* self, gint index, GeeCollection* collection);
	void (*sort) (GeeList* self, GCompareDataFunc compare_func, gpointer compare_func_target, GDestroyNotify compare_func_target_destroy_notify);
	GeeList* (*get_read_only_view) (GeeList* self);
};

struct _GeeAbstractList {
	GeeAbstractCollection parent_instance;
	GeeAbstractListPrivate * priv;
};

struct _GeeAbstractListClass {
	GeeAbstractCollectionClass parent_class;
	GeeListIterator* (*list_iterator) (GeeAbstractList* self);
	gpointer (*get) (GeeAbstractList* self, gint index);
	void (*set) (GeeAbstractList* self, gint index, gconstpointer item);
	gint (*index_of) (GeeAbstractList* self, gconstpointer item);
	void (*insert) (GeeAbstractList* self, gint index, gconstpointer item);
	gpointer (*remove_at) (GeeAbstractList* self, gint index);
	GeeList* (*slice) (GeeAbstractList* self, gint start, gint stop);
	void (*reserved0) (GeeAbstractList* self);
	void (*reserved1) (GeeAbstractList* self);
	void (*reserved2) (GeeAbstractList* self);
	void (*reserved3) (GeeAbstractList* self);
	void (*reserved4) (GeeAbstractList* self);
	void (*reserved5) (GeeAbstractList* self);
	void (*reserved6) (GeeAbstractList* self);
	void (*reserved7) (GeeAbstractList* self);
	void (*reserved8) (GeeAbstractList* self);
	void (*reserved9) (GeeAbstractList* self);
	GeeList* (*get_read_only_view) (GeeAbstractList* self);
};

struct _GeeAbstractListPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	GWeakRef _read_only_view;
};

static gint GeeAbstractList_private_offset;
static gpointer gee_abstract_list_parent_class = NULL;
static GeeListIface * gee_abstract_list_gee_list_parent_iface = NULL;

GType gee_traversable_stream_get_type (void) G_GNUC_CONST;
gpointer gee_lazy_ref (gpointer instance);
void gee_lazy_unref (gpointer instance);
GParamSpec* gee_param_spec_lazy (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags);
void gee_value_set_lazy (GValue* value,
                         gpointer v_object);
void gee_value_take_lazy (GValue* value,
                          gpointer v_object);
gpointer gee_value_get_lazy (const GValue* value);
GType gee_lazy_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GeeLazy, gee_lazy_unref)
GType gee_iterator_get_type (void) G_GNUC_CONST;
GType gee_traversable_get_type (void) G_GNUC_CONST;
GType gee_iterable_get_type (void) G_GNUC_CONST;
GType gee_collection_get_type (void) G_GNUC_CONST;
GType gee_abstract_collection_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GeeAbstractCollection, g_object_unref)
GType gee_list_iterator_get_type (void) G_GNUC_CONST;
GType gee_list_get_type (void) G_GNUC_CONST;
GType gee_abstract_list_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GeeAbstractList, g_object_unref)
GeeListIterator* gee_abstract_list_list_iterator (GeeAbstractList* self);
static GeeListIterator* gee_abstract_list_real_list_iterator (GeeAbstractList* self);
gpointer gee_abstract_list_get (GeeAbstractList* self,
                                gint index);
static gpointer gee_abstract_list_real_get (GeeAbstractList* self,
                                     gint index);
void gee_abstract_list_set (GeeAbstractList* self,
                            gint index,
                            gconstpointer item);
static void gee_abstract_list_real_set (GeeAbstractList* self,
                                 gint index,
                                 gconstpointer item);
gint gee_abstract_list_index_of (GeeAbstractList* self,
                                 gconstpointer item);
static gint gee_abstract_list_real_index_of (GeeAbstractList* self,
                                      gconstpointer item);
void gee_abstract_list_insert (GeeAbstractList* self,
                               gint index,
                               gconstpointer item);
static void gee_abstract_list_real_insert (GeeAbstractList* self,
                                    gint index,
                                    gconstpointer item);
gpointer gee_abstract_list_remove_at (GeeAbstractList* self,
                                      gint index);
static gpointer gee_abstract_list_real_remove_at (GeeAbstractList* self,
                                           gint index);
GeeList* gee_abstract_list_slice (GeeAbstractList* self,
                                  gint start,
                                  gint stop);
static GeeList* gee_abstract_list_real_slice (GeeAbstractList* self,
                                       gint start,
                                       gint stop);
G_GNUC_INTERNAL void gee_abstract_list_reserved0 (GeeAbstractList* self);
static void gee_abstract_list_real_reserved0 (GeeAbstractList* self);
G_GNUC_INTERNAL void gee_abstract_list_reserved1 (GeeAbstractList* self);
static void gee_abstract_list_real_reserved1 (GeeAbstractList* self);
G_GNUC_INTERNAL void gee_abstract_list_reserved2 (GeeAbstractList* self);
static void gee_abstract_list_real_reserved2 (GeeAbstractList* self);
G_GNUC_INTERNAL void gee_abstract_list_reserved3 (GeeAbstractList* self);
static void gee_abstract_list_real_reserved3 (GeeAbstractList* self);
G_GNUC_INTERNAL void gee_abstract_list_reserved4 (GeeAbstractList* self);
static void gee_abstract_list_real_reserved4 (GeeAbstractList* self);
G_GNUC_INTERNAL void gee_abstract_list_reserved5 (GeeAbstractList* self);
static void gee_abstract_list_real_reserved5 (GeeAbstractList* self);
G_GNUC_INTERNAL void gee_abstract_list_reserved6 (GeeAbstractList* self);
static void gee_abstract_list_real_reserved6 (GeeAbstractList* self);
G_GNUC_INTERNAL void gee_abstract_list_reserved7 (GeeAbstractList* self);
static void gee_abstract_list_real_reserved7 (GeeAbstractList* self);
G_GNUC_INTERNAL void gee_abstract_list_reserved8 (GeeAbstractList* self);
static void gee_abstract_list_real_reserved8 (GeeAbstractList* self);
G_GNUC_INTERNAL void gee_abstract_list_reserved9 (GeeAbstractList* self);
static void gee_abstract_list_real_reserved9 (GeeAbstractList* self);
GeeAbstractList* gee_abstract_list_construct (GType object_type,
                                              GType g_type,
                                              GBoxedCopyFunc g_dup_func,
                                              GDestroyNotify g_destroy_func);
GeeAbstractCollection* gee_abstract_collection_construct (GType object_type,
                                                          GType g_type,
                                                          GBoxedCopyFunc g_dup_func,
                                                          GDestroyNotify g_destroy_func);
GeeList* gee_abstract_list_get_read_only_view (GeeAbstractList* self);
G_GNUC_INTERNAL GeeReadOnlyList* gee_read_only_list_new (GType g_type,
                                         GBoxedCopyFunc g_dup_func,
                                         GDestroyNotify g_destroy_func,
                                         GeeList* list);
G_GNUC_INTERNAL GeeReadOnlyList* gee_read_only_list_construct (GType object_type,
                                               GType g_type,
                                               GBoxedCopyFunc g_dup_func,
                                               GDestroyNotify g_destroy_func,
                                               GeeList* list);
G_GNUC_INTERNAL GType gee_read_only_collection_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GeeReadOnlyCollection, g_object_unref)
G_GNUC_INTERNAL GType gee_read_only_list_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GeeReadOnlyList, g_object_unref)
static GObject * gee_abstract_list_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void gee_abstract_list_finalize (GObject * obj);
static void _vala_gee_abstract_list_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_gee_abstract_list_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
gee_abstract_list_get_instance_private (GeeAbstractList* self)
{
	return G_STRUCT_MEMBER_P (self, GeeAbstractList_private_offset);
}

/**
 * {@inheritDoc}
 */
static GeeListIterator*
gee_abstract_list_real_list_iterator (GeeAbstractList* self)
{
	g_critical ("Type `%s' does not implement abstract method `gee_abstract_list_list_iterator'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

GeeListIterator*
gee_abstract_list_list_iterator (GeeAbstractList* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GEE_ABSTRACT_LIST_GET_CLASS (self)->list_iterator (self);
}

/**
 * {@inheritDoc}
 */
static gpointer
gee_abstract_list_real_get (GeeAbstractList* self,
                            gint index)
{
	g_critical ("Type `%s' does not implement abstract method `gee_abstract_list_get'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

gpointer
gee_abstract_list_get (GeeAbstractList* self,
                       gint index)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GEE_ABSTRACT_LIST_GET_CLASS (self)->get (self, index);
}

/**
 * {@inheritDoc}
 */
static void
gee_abstract_list_real_set (GeeAbstractList* self,
                            gint index,
                            gconstpointer item)
{
	g_critical ("Type `%s' does not implement abstract method `gee_abstract_list_set'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
gee_abstract_list_set (GeeAbstractList* self,
                       gint index,
                       gconstpointer item)
{
	g_return_if_fail (self != NULL);
	GEE_ABSTRACT_LIST_GET_CLASS (self)->set (self, index, item);
}

/**
 * {@inheritDoc}
 */
static gint
gee_abstract_list_real_index_of (GeeAbstractList* self,
                                 gconstpointer item)
{
	gint _tmp0_ = 0;
	g_critical ("Type `%s' does not implement abstract method `gee_abstract_list_index_of'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}

gint
gee_abstract_list_index_of (GeeAbstractList* self,
                            gconstpointer item)
{
	g_return_val_if_fail (self != NULL, 0);
	return GEE_ABSTRACT_LIST_GET_CLASS (self)->index_of (self, item);
}

/**
 * {@inheritDoc}
 */
static void
gee_abstract_list_real_insert (GeeAbstractList* self,
                               gint index,
                               gconstpointer item)
{
	g_critical ("Type `%s' does not implement abstract method `gee_abstract_list_insert'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
gee_abstract_list_insert (GeeAbstractList* self,
                          gint index,
                          gconstpointer item)
{
	g_return_if_fail (self != NULL);
	GEE_ABSTRACT_LIST_GET_CLASS (self)->insert (self, index, item);
}

/**
 * {@inheritDoc}
 */
static gpointer
gee_abstract_list_real_remove_at (GeeAbstractList* self,
                                  gint index)
{
	g_critical ("Type `%s' does not implement abstract method `gee_abstract_list_remove_at'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

gpointer
gee_abstract_list_remove_at (GeeAbstractList* self,
                             gint index)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GEE_ABSTRACT_LIST_GET_CLASS (self)->remove_at (self, index);
}

/**
 * {@inheritDoc}
 */
static GeeList*
gee_abstract_list_real_slice (GeeAbstractList* self,
                              gint start,
                              gint stop)
{
	g_critical ("Type `%s' does not implement abstract method `gee_abstract_list_slice'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

GeeList*
gee_abstract_list_slice (GeeAbstractList* self,
                         gint start,
                         gint stop)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GEE_ABSTRACT_LIST_GET_CLASS (self)->slice (self, start, stop);
}

static void
gee_abstract_list_real_reserved0 (GeeAbstractList* self)
{
}

void
gee_abstract_list_reserved0 (GeeAbstractList* self)
{
	g_return_if_fail (self != NULL);
	GEE_ABSTRACT_LIST_GET_CLASS (self)->reserved0 (self);
}

static void
gee_abstract_list_real_reserved1 (GeeAbstractList* self)
{
}

void
gee_abstract_list_reserved1 (GeeAbstractList* self)
{
	g_return_if_fail (self != NULL);
	GEE_ABSTRACT_LIST_GET_CLASS (self)->reserved1 (self);
}

static void
gee_abstract_list_real_reserved2 (GeeAbstractList* self)
{
}

void
gee_abstract_list_reserved2 (GeeAbstractList* self)
{
	g_return_if_fail (self != NULL);
	GEE_ABSTRACT_LIST_GET_CLASS (self)->reserved2 (self);
}

static void
gee_abstract_list_real_reserved3 (GeeAbstractList* self)
{
}

void
gee_abstract_list_reserved3 (GeeAbstractList* self)
{
	g_return_if_fail (self != NULL);
	GEE_ABSTRACT_LIST_GET_CLASS (self)->reserved3 (self);
}

static void
gee_abstract_list_real_reserved4 (GeeAbstractList* self)
{
}

void
gee_abstract_list_reserved4 (GeeAbstractList* self)
{
	g_return_if_fail (self != NULL);
	GEE_ABSTRACT_LIST_GET_CLASS (self)->reserved4 (self);
}

static void
gee_abstract_list_real_reserved5 (GeeAbstractList* self)
{
}

void
gee_abstract_list_reserved5 (GeeAbstractList* self)
{
	g_return_if_fail (self != NULL);
	GEE_ABSTRACT_LIST_GET_CLASS (self)->reserved5 (self);
}

static void
gee_abstract_list_real_reserved6 (GeeAbstractList* self)
{
}

void
gee_abstract_list_reserved6 (GeeAbstractList* self)
{
	g_return_if_fail (self != NULL);
	GEE_ABSTRACT_LIST_GET_CLASS (self)->reserved6 (self);
}

static void
gee_abstract_list_real_reserved7 (GeeAbstractList* self)
{
}

void
gee_abstract_list_reserved7 (GeeAbstractList* self)
{
	g_return_if_fail (self != NULL);
	GEE_ABSTRACT_LIST_GET_CLASS (self)->reserved7 (self);
}

static void
gee_abstract_list_real_reserved8 (GeeAbstractList* self)
{
}

void
gee_abstract_list_reserved8 (GeeAbstractList* self)
{
	g_return_if_fail (self != NULL);
	GEE_ABSTRACT_LIST_GET_CLASS (self)->reserved8 (self);
}

static void
gee_abstract_list_real_reserved9 (GeeAbstractList* self)
{
}

void
gee_abstract_list_reserved9 (GeeAbstractList* self)
{
	g_return_if_fail (self != NULL);
	GEE_ABSTRACT_LIST_GET_CLASS (self)->reserved9 (self);
}

GeeAbstractList*
gee_abstract_list_construct (GType object_type,
                             GType g_type,
                             GBoxedCopyFunc g_dup_func,
                             GDestroyNotify g_destroy_func)
{
	GeeAbstractList * self = NULL;
	self = (GeeAbstractList*) gee_abstract_collection_construct (object_type, g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func);
	self->priv->g_type = g_type;
	self->priv->g_dup_func = g_dup_func;
	self->priv->g_destroy_func = g_destroy_func;
	return self;
}

GeeList*
gee_abstract_list_get_read_only_view (GeeAbstractList* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return GEE_ABSTRACT_LIST_GET_CLASS (self)->get_read_only_view (self);
}

static GeeList*
gee_abstract_list_real_get_read_only_view (GeeAbstractList* base)
{
	GeeList* result;
	GeeAbstractList* self;
	GeeList* instance = NULL;
	GObject* _tmp0_;
	GeeList* _tmp1_;
	self = base;
	_tmp0_ = g_weak_ref_get (&self->priv->_read_only_view);
	instance = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
	_tmp1_ = instance;
	if (_tmp1_ == NULL) {
		GeeReadOnlyList* _tmp2_;
		GeeList* _tmp3_;
		_tmp2_ = gee_read_only_list_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, (GDestroyNotify) self->priv->g_destroy_func, (GeeList*) self);
		_g_object_unref0 (instance);
		instance = (GeeList*) _tmp2_;
		_tmp3_ = instance;
		g_weak_ref_set (&self->priv->_read_only_view, (GObject*) _tmp3_);
	}
	result = instance;
	return result;
}

static GObject *
gee_abstract_list_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GeeAbstractList * self;
	parent_class = G_OBJECT_CLASS (gee_abstract_list_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList);
	g_weak_ref_clear (&self->priv->_read_only_view);
	g_weak_ref_init (&self->priv->_read_only_view, NULL);
	return obj;
}

static void
gee_abstract_list_class_init (GeeAbstractListClass * klass,
                              gpointer klass_data)
{
	gee_abstract_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GeeAbstractList_private_offset);
	((GeeAbstractListClass *) klass)->list_iterator = (GeeListIterator* (*) (GeeAbstractList*)) gee_abstract_list_real_list_iterator;
	((GeeAbstractListClass *) klass)->get = (gpointer (*) (GeeAbstractList*, gint)) gee_abstract_list_real_get;
	((GeeAbstractListClass *) klass)->set = (void (*) (GeeAbstractList*, gint, gconstpointer)) gee_abstract_list_real_set;
	((GeeAbstractListClass *) klass)->index_of = (gint (*) (GeeAbstractList*, gconstpointer)) gee_abstract_list_real_index_of;
	((GeeAbstractListClass *) klass)->insert = (void (*) (GeeAbstractList*, gint, gconstpointer)) gee_abstract_list_real_insert;
	((GeeAbstractListClass *) klass)->remove_at = (gpointer (*) (GeeAbstractList*, gint)) gee_abstract_list_real_remove_at;
	((GeeAbstractListClass *) klass)->slice = (GeeList* (*) (GeeAbstractList*, gint, gint)) gee_abstract_list_real_slice;
	((GeeAbstractListClass *) klass)->reserved0 = (void (*) (GeeAbstractList*)) gee_abstract_list_real_reserved0;
	((GeeAbstractListClass *) klass)->reserved1 = (void (*) (GeeAbstractList*)) gee_abstract_list_real_reserved1;
	((GeeAbstractListClass *) klass)->reserved2 = (void (*) (GeeAbstractList*)) gee_abstract_list_real_reserved2;
	((GeeAbstractListClass *) klass)->reserved3 = (void (*) (GeeAbstractList*)) gee_abstract_list_real_reserved3;
	((GeeAbstractListClass *) klass)->reserved4 = (void (*) (GeeAbstractList*)) gee_abstract_list_real_reserved4;
	((GeeAbstractListClass *) klass)->reserved5 = (void (*) (GeeAbstractList*)) gee_abstract_list_real_reserved5;
	((GeeAbstractListClass *) klass)->reserved6 = (void (*) (GeeAbstractList*)) gee_abstract_list_real_reserved6;
	((GeeAbstractListClass *) klass)->reserved7 = (void (*) (GeeAbstractList*)) gee_abstract_list_real_reserved7;
	((GeeAbstractListClass *) klass)->reserved8 = (void (*) (GeeAbstractList*)) gee_abstract_list_real_reserved8;
	((GeeAbstractListClass *) klass)->reserved9 = (void (*) (GeeAbstractList*)) gee_abstract_list_real_reserved9;
	GEE_ABSTRACT_LIST_CLASS (klass)->get_read_only_view = gee_abstract_list_real_get_read_only_view;
	G_OBJECT_CLASS (klass)->get_property = _vala_gee_abstract_list_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gee_abstract_list_set_property;
	G_OBJECT_CLASS (klass)->constructor = gee_abstract_list_constructor;
	G_OBJECT_CLASS (klass)->finalize = gee_abstract_list_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_ABSTRACT_LIST_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_ABSTRACT_LIST_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_STRINGS | G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_ABSTRACT_LIST_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_STRINGS | G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * {@inheritDoc}
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_ABSTRACT_LIST_READ_ONLY_VIEW_PROPERTY, gee_abstract_list_properties[GEE_ABSTRACT_LIST_READ_ONLY_VIEW_PROPERTY] = g_param_spec_object ("read-only-view", "read-only-view", "read-only-view", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static GType
gee_abstract_list_gee_list_get_g_type (GeeAbstractList* self)
{
	return self->priv->g_type;
}

static GBoxedCopyFunc
gee_abstract_list_gee_list_get_g_dup_func (GeeAbstractList* self)
{
	return self->priv->g_dup_func;
}

static GDestroyNotify
gee_abstract_list_gee_list_get_g_destroy_func (GeeAbstractList* self)
{
	return self->priv->g_destroy_func;
}

static void
gee_abstract_list_gee_list_interface_init (GeeListIface * iface,
                                           gpointer iface_data)
{
	gee_abstract_list_gee_list_parent_iface = g_type_interface_peek_parent (iface);
	iface->list_iterator = (GeeListIterator* (*) (GeeList*)) gee_abstract_list_list_iterator;
	iface->get = (gpointer (*) (GeeList*, gint)) gee_abstract_list_get;
	iface->set = (void (*) (GeeList*, gint, gconstpointer)) gee_abstract_list_set;
	iface->index_of = (gint (*) (GeeList*, gconstpointer)) gee_abstract_list_index_of;
	iface->insert = (void (*) (GeeList*, gint, gconstpointer)) gee_abstract_list_insert;
	iface->remove_at = (gpointer (*) (GeeList*, gint)) gee_abstract_list_remove_at;
	iface->slice = (GeeList* (*) (GeeList*, gint, gint)) gee_abstract_list_slice;
	iface->get_g_type = (GType (*) (GeeList *)) gee_abstract_list_gee_list_get_g_type;
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeList *)) gee_abstract_list_gee_list_get_g_dup_func;
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeList *)) gee_abstract_list_gee_list_get_g_destroy_func;
	iface->get_read_only_view = (GeeList* (*) (GeeList *)) gee_abstract_list_get_read_only_view;
}

static void
gee_abstract_list_instance_init (GeeAbstractList * self,
                                 gpointer klass)
{
	self->priv = gee_abstract_list_get_instance_private (self);
}

static void
gee_abstract_list_finalize (GObject * obj)
{
	GeeAbstractList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList);
	g_weak_ref_clear (&self->priv->_read_only_view);
	G_OBJECT_CLASS (gee_abstract_list_parent_class)->finalize (obj);
}

/**
 * Skeletal implementation of the {@link List} interface.
 *
 * Contains common code shared by all list implementations.
 *
 * @see ArrayList
 * @see LinkedList
 */
GType
gee_abstract_list_get_type (void)
{
	static volatile gsize gee_abstract_list_type_id__volatile = 0;
	if (g_once_init_enter (&gee_abstract_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GeeAbstractListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gee_abstract_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GeeAbstractList), 0, (GInstanceInitFunc) gee_abstract_list_instance_init, NULL };
		static const GInterfaceInfo gee_list_info = { (GInterfaceInitFunc) gee_abstract_list_gee_list_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType gee_abstract_list_type_id;
		gee_abstract_list_type_id = g_type_register_static (GEE_TYPE_ABSTRACT_COLLECTION, "GeeAbstractList", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_type_add_interface_static (gee_abstract_list_type_id, GEE_TYPE_LIST, &gee_list_info);
		GeeAbstractList_private_offset = g_type_add_instance_private (gee_abstract_list_type_id, sizeof (GeeAbstractListPrivate));
		g_once_init_leave (&gee_abstract_list_type_id__volatile, gee_abstract_list_type_id);
	}
	return gee_abstract_list_type_id__volatile;
}

static void
_vala_gee_abstract_list_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	GeeAbstractList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList);
	switch (property_id) {
		case GEE_ABSTRACT_LIST_READ_ONLY_VIEW_PROPERTY:
		g_value_take_object (value, gee_abstract_list_get_read_only_view (self));
		break;
		case GEE_ABSTRACT_LIST_G_TYPE:
		g_value_set_gtype (value, self->priv->g_type);
		break;
		case GEE_ABSTRACT_LIST_G_DUP_FUNC:
		g_value_set_pointer (value, self->priv->g_dup_func);
		break;
		case GEE_ABSTRACT_LIST_G_DESTROY_FUNC:
		g_value_set_pointer (value, self->priv->g_destroy_func);
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gee_abstract_list_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	GeeAbstractList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList);
	switch (property_id) {
		case GEE_ABSTRACT_LIST_G_TYPE:
		self->priv->g_type = g_value_get_gtype (value);
		break;
		case GEE_ABSTRACT_LIST_G_DUP_FUNC:
		self->priv->g_dup_func = g_value_get_pointer (value);
		break;
		case GEE_ABSTRACT_LIST_G_DESTROY_FUNC:
		self->priv->g_destroy_func = g_value_get_pointer (value);
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

